searchNodes=[{"doc":"Pure Elixir package used to generate and read private/public key pairs in PEM and DER formats, sign and verify messages using the Elliptic Curve Digital Signature Algorithmn (ECDSA). Submodules: Ecdsa: verifies and signs messages; Signature: loads and dumps signatures; PrivateKey: creates, loads and dumps private keys; also creates public keys from private keys; PublicKey: loads and dumps public keys;","ref":"EllipticCurve.html","title":"EllipticCurve","type":"module"},{"doc":"","ref":"EllipticCurve.Curve.Data.html","title":"EllipticCurve.Curve.Data","type":"module"},{"doc":"Describes the elliptic curves supported by the package","ref":"EllipticCurve.Curve.KnownCurves.html","title":"EllipticCurve.Curve.KnownCurves","type":"module"},{"doc":"","ref":"EllipticCurve.Curve.KnownCurves.html#getCurveByName/1","title":"EllipticCurve.Curve.KnownCurves.getCurveByName/1","type":"function"},{"doc":"","ref":"EllipticCurve.Curve.KnownCurves.html#getCurveByOid/1","title":"EllipticCurve.Curve.KnownCurves.getCurveByOid/1","type":"function"},{"doc":"","ref":"EllipticCurve.Curve.KnownCurves.html#prime256v1/0","title":"EllipticCurve.Curve.KnownCurves.prime256v1/0","type":"function"},{"doc":"","ref":"EllipticCurve.Curve.KnownCurves.html#secp256k1/0","title":"EllipticCurve.Curve.KnownCurves.secp256k1/0","type":"function"},{"doc":"Used to sign and verify signatures using the Elliptic Curve Digital Signature Algorithm (ECDSA) Functions: sign() verify?()","ref":"EllipticCurve.Ecdsa.html","title":"EllipticCurve.Ecdsa","type":"module"},{"doc":"Generates a message signature based on a private key Parameters: message [string]: message that will be signed privateKey [%EllipticCurve.PrivateKey.Data]: private key data associated with the signer options [keyword list]: refines request hashfunc [:method]: defines the hash function applied to the message. Must be compatible with :crypto.hash. Default: :sha256; Returns signature: signature [string]: base-64 message signature; Example: iex&gt; EllipticCurve.Ecdsa.sign(&quot;my message&quot;, privateKey) &quot;MEQCIFp2TrQ6RlThbEOeYin2t+Dz3TAebeK/kinZaU0Iltm4AiBXyvyCTwgjOBo5eZNssw/3shTqn8eHZyoRiToSttrRFw==&quot;","ref":"EllipticCurve.Ecdsa.html#sign/3","title":"EllipticCurve.Ecdsa.sign/3","type":"function"},{"doc":"Verifies a message signature based on a public key Parameters: message [string]: message that will be signed signature [%EllipticCurve.Signature.Data]: signature associated with the message publicKey [%EllipticCurve.PublicKey.Data]: public key associated with the message signer options [keyword list]: refines request hashfunc [:method]: defines the hash function applied to the message. Must be compatible with :crypto.hash. Default: :sha256; Returns: verified [bool]: true if message, public key and signature are compatible, false otherwise; Example: iex&gt; EllipticCurve.Ecdsa.verify?(message, signature, publicKey) true iex&gt; EllipticCurve.Ecdsa.verify?(wrongMessage, signature, publicKey) false iex&gt; EllipticCurve.Ecdsa.verify?(message, wrongSignature, publicKey) false iex&gt; EllipticCurve.Ecdsa.verify?(message, signature, wrongPublicKey) false","ref":"EllipticCurve.Ecdsa.html#verify?/4","title":"EllipticCurve.Ecdsa.verify?/4","type":"function"},{"doc":"Used to create private keys or convert them between struct and .der or .pem formats. Also allows creations of public keys from private keys. Functions: generate() toPem() toDer() fromPem() fromPem!() fromDer() fromDer!()","ref":"EllipticCurve.PrivateKey.html","title":"EllipticCurve.PrivateKey","type":"module"},{"doc":"Converts a private key in der format into decoded struct format Parameters: der [string]: private key in der format Returns {:ok, privateKey}: privateKey [%EllipticCurve.PrivateKey.Data]: decoded private key struct; Example: iex&gt; EllipticCurve.PrivateKey.fromDer(&lt;&lt;48, 116, 2, 1, 1, 4, 32, 59, 210, 253, 23, 93, 23, ...&gt;&gt;) {:ok, %EllipticCurve.PrivateKey.Data{...}}","ref":"EllipticCurve.PrivateKey.html#fromDer/1","title":"EllipticCurve.PrivateKey.fromDer/1","type":"function"},{"doc":"Converts a private key in der format into decoded struct format Parameters: der [string]: private key in der format Returns: privateKey [%EllipticCurve.PrivateKey.Data]: decoded private key struct; Example: iex&gt; EllipticCurve.PrivateKey.fromDer!(&lt;&lt;48, 116, 2, 1, 1, 4, 32, 59, 210, 253, 23, 93, 23, ...&gt;&gt;) %EllipticCurve.PrivateKey.Data{...}","ref":"EllipticCurve.PrivateKey.html#fromDer!/1","title":"EllipticCurve.PrivateKey.fromDer!/1","type":"function"},{"doc":"Converts a private key in pem format into decoded struct format Parameters: pem [string]: private key in pem format Returns {:ok, privateKey}: privateKey [%EllipticCurve.PrivateKey.Data]: decoded private key struct; Example: iex&gt; EllipticCurve.PrivateKey.fromPem(&quot;-----BEGIN EC PRIVATE KEY----- MHQCAQEEIDvS/RddF6iYa/q4oVSrGa3Kbd7aSooNpwhv9puJVv1loAcGBSuBBAAK oUQDQgAErp2I78X4cqHscCRWMT4rhouyO197iQXRfdGgsgfS/UGaIviYiqnG3SSa 9dsOHU/NkVSTLkBPCI0RQLF3554dZg== -----END EC PRIVATE KEY----- &quot;) {:ok, %EllipticCurve.PrivateKey.Data{...}}","ref":"EllipticCurve.PrivateKey.html#fromPem/1","title":"EllipticCurve.PrivateKey.fromPem/1","type":"function"},{"doc":"Converts a private key in pem format into decoded struct format Parameters: pem [string]: private key in pem format Returns: privateKey [%EllipticCurve.PrivateKey.Data]: decoded private key struct; Example: iex&gt; EllipticCurve.PrivateKey.fromPem!(&quot;-----BEGIN EC PRIVATE KEY----- MHQCAQEEIDvS/RddF6iYa/q4oVSrGa3Kbd7aSooNpwhv9puJVv1loAcGBSuBBAAK oUQDQgAErp2I78X4cqHscCRWMT4rhouyO197iQXRfdGgsgfS/UGaIviYiqnG3SSa 9dsOHU/NkVSTLkBPCI0RQLF3554dZg== -----END EC PRIVATE KEY----- &quot;) %EllipticCurve.PrivateKey.Data{...}","ref":"EllipticCurve.PrivateKey.html#fromPem!/1","title":"EllipticCurve.PrivateKey.fromPem!/1","type":"function"},{"doc":"Creates a new private key Parameters: secret [int]: private key secret; Default: nil -&gt; random key will be generated; curve [atom]: curve name; Default: :secp256k1; Returns: privateKey [%EllipticCurve.PrivateKey.Data]: private key struct Example: iex&gt; EllipticCurve.PrivateKey.generate() %EllipticCurve.PrivateKey.Data{...}","ref":"EllipticCurve.PrivateKey.html#generate/2","title":"EllipticCurve.PrivateKey.generate/2","type":"function"},{"doc":"Gets the public associated with a private key Parameters: privateKey [%EllipticCurve.PrivateKey.Data]: private key struct Returns: publicKey [%EllipticCurve.PublicKey.Data]: public key struct Example: iex&gt; EllipticCurve.PrivateKey.getPublicKey(privateKey) %EllipticCurve.PublicKey.Data{...}","ref":"EllipticCurve.PrivateKey.html#getPublicKey/1","title":"EllipticCurve.PrivateKey.getPublicKey/1","type":"function"},{"doc":"Converts a private key in decoded struct format into a der string (raw binary) Parameters: privateKey [$EllipticCurve.PrivateKey.Data]: decoded private key struct; Returns: der [string]: private key in der format Example: iex&gt; EllipticCurve.PrivateKey.toDer(%EllipticCurve.PrivateKey.Data{...}) &lt;&lt;48, 116, 2, 1, 1, 4, 32, 59, 210, 253, 23, 93, 23, ...&gt;&gt;","ref":"EllipticCurve.PrivateKey.html#toDer/1","title":"EllipticCurve.PrivateKey.toDer/1","type":"function"},{"doc":"Converts a private key in decoded struct format into a pem string Parameters: privateKey [%EllipticCurve.PrivateKey.Data]: decoded private key struct; Returns: pem [string]: private key in pem format Example: iex&gt; EllipticCurve.PrivateKey.toPem(%EllipticCurve.PrivateKey.Data{...}) &quot;-----BEGIN EC PRIVATE KEY----- MHQCAQEEIDvS/RddF6iYa/q4oVSrGa3Kbd7aSooNpwhv9puJVv1loAcGBSuBBAAK oUQDQgAErp2I78X4cqHscCRWMT4rhouyO197iQXRfdGgsgfS/UGaIviYiqnG3SSa 9dsOHU/NkVSTLkBPCI0RQLF3554dZg== -----END EC PRIVATE KEY----- &quot;","ref":"EllipticCurve.PrivateKey.html#toPem/1","title":"EllipticCurve.PrivateKey.toPem/1","type":"function"},{"doc":"","ref":"EllipticCurve.PrivateKey.Data.html","title":"EllipticCurve.PrivateKey.Data","type":"module"},{"doc":"Holds private key data. Is usually extracted from .pem files. Parameters: secret [integer]: private key secret number; curve [%EllipticCurve.Curve.Data]: private key curve information;","ref":"EllipticCurve.PrivateKey.Data.html#__struct__/0","title":"EllipticCurve.PrivateKey.Data.__struct__/0","type":"function"},{"doc":"Used to convert public keys between struct and .der or .pem formats. Functions: toPem() toDer() fromPem() fromPem!() fromDer() fromDer!()","ref":"EllipticCurve.PublicKey.html","title":"EllipticCurve.PublicKey","type":"module"},{"doc":"Converts a public key in der (raw binary) format into decoded struct format Parameters: der [string]: public key in der format Returns {:ok, publicKey}: publicKey [%EllipticCurve.PublicKey.Data]: decoded public key struct; Example: iex&gt; EllipticCurve.PublicKey.fromDer(&lt;&lt;48, 86, 48, 16, 6, 7, 42, 134, ...&gt;&gt;) {:ok, %EllipticCurve.PublicKey.Data{...}}","ref":"EllipticCurve.PublicKey.html#fromDer/1","title":"EllipticCurve.PublicKey.fromDer/1","type":"function"},{"doc":"Converts a public key in der (raw binary) format into decoded struct format Parameters: der [string]: public key in der format Returns: publicKey [%EllipticCurve.PublicKey.Data]: decoded public key struct; Example: iex&gt; EllipticCurve.PublicKey.fromDer!(&lt;&lt;48, 86, 48, 16, 6, 7, 42, 134, ...&gt;&gt;) %EllipticCurve.PublicKey.Data{...}","ref":"EllipticCurve.PublicKey.html#fromDer!/1","title":"EllipticCurve.PublicKey.fromDer!/1","type":"function"},{"doc":"Converts a public key in pem format into decoded struct format Parameters: pem [string]: public key in pem format Returns {:ok, publicKey}: publicKey [%EllipticCurve.PublicKey.Data]: decoded public key struct; Example: iex&gt; EllipticCurve.PublicKey.fromPem(&quot;-----BEGIN PUBLIC KEY----- MFYwEAYHKoZIzj0CAQYFK4EEAAoDQgAErp2I78X4cqHscCRWMT4rhouyO197iQXR fdGgsgfS/UGaIviYiqnG3SSa9dsOHU/NkVSTLkBPCI0RQLF3554dZg== -----END PUBLIC KEY----- &quot;) {:ok, %EllipticCurve.PublicKey.Data{...}}","ref":"EllipticCurve.PublicKey.html#fromPem/1","title":"EllipticCurve.PublicKey.fromPem/1","type":"function"},{"doc":"Converts a public key in pem format into decoded struct format Parameters: pem [string]: public key in pem format Returns: publicKey [%EllipticCurve.PublicKey.Data]: decoded public key struct; Example: iex&gt; EllipticCurve.PublicKey.fromPem!(&quot;-----BEGIN PUBLIC KEY----- MFYwEAYHKoZIzj0CAQYFK4EEAAoDQgAErp2I78X4cqHscCRWMT4rhouyO197iQXR fdGgsgfS/UGaIviYiqnG3SSa9dsOHU/NkVSTLkBPCI0RQLF3554dZg== -----END PUBLIC KEY----- &quot;) %EllipticCurve.PublicKey.Data{...}","ref":"EllipticCurve.PublicKey.html#fromPem!/1","title":"EllipticCurve.PublicKey.fromPem!/1","type":"function"},{"doc":"Converts a public key in decoded struct format into a der string (raw binary) Parameters: publicKey [%EllipticCurve.PublicKey.Data]: decoded public key struct; Returns: der [string]: public key in der format Example: iex&gt; EllipticCurve.PublicKey.toDer(%EllipticCurve.PublicKey.Data{...}) &lt;&lt;48, 86, 48, 16, 6, 7, 42, 134, 72, 206, 61, ...&gt;&gt;","ref":"EllipticCurve.PublicKey.html#toDer/1","title":"EllipticCurve.PublicKey.toDer/1","type":"function"},{"doc":"Converts a public key in decoded struct format into a pem string Parameters: publicKey [%EllipticCurve.PublicKey.Data]: decoded public key struct; Returns: pem [string]: public key in pem format Example: iex&gt; EllipticCurve.PublicKey.toPem(%EllipticCurve.PublicKey.Data{...}) &quot;-----BEGIN PUBLIC KEY----- MFYwEAYHKoZIzj0CAQYFK4EEAAoDQgAErp2I78X4cqHscCRWMT4rhouyO197iQXR fdGgsgfS/UGaIviYiqnG3SSa9dsOHU/NkVSTLkBPCI0RQLF3554dZg== -----END PUBLIC KEY----- &quot;","ref":"EllipticCurve.PublicKey.html#toPem/1","title":"EllipticCurve.PublicKey.toPem/1","type":"function"},{"doc":"","ref":"EllipticCurve.PublicKey.Data.html","title":"EllipticCurve.PublicKey.Data","type":"module"},{"doc":"Holds public key data. Is usually extracted from .pem files or from the private key itself. Parameters: point [%EllipticCurve.Utils.Point]: public key point data; curve [%EllipticCurve.Curve.Data]: public key curve information;","ref":"EllipticCurve.PublicKey.Data.html#__struct__/0","title":"EllipticCurve.PublicKey.Data.__struct__/0","type":"function"},{"doc":"Used to convert signature between struct (raw numbers r and s) and .der or .pem formats. Functions: fromBase64() fromBase64!() fromDer() fromDer!() toBase64() toDer()","ref":"EllipticCurve.Signature.html","title":"EllipticCurve.Signature","type":"module"},{"doc":"Converts a base 64 signature into the decoded struct format Parameters: base64 [string]: message that will be signed Returns {:ok, signature}: signature [%EllipticCurve.Signature.Data]: decoded signature, exposing r and s; Example: iex&gt; EllipticCurve.Ecdsa.fromBase64(&quot;MEYCIQD861pJq/fZE7GnDBycwAbb3YglVoSCVub6TwMkgFS0NgIhAJCEZTh1Mlp1cWCgMXABqh9nOQznEXnhGoSYmZK6T99T&quot;) {:ok, %EllipticCurve.Signature.Data{r: 114398670046563728651181765316495176217036114587592994448444521545026466264118, s: 65366972607021398158454632864220554542282541376523937745916477386966386597715}}","ref":"EllipticCurve.Signature.html#fromBase64/1","title":"EllipticCurve.Signature.fromBase64/1","type":"function"},{"doc":"Converts a base 64 signature into the decoded struct format Parameters: base64 [string]: signature in base 64 format Returns {:ok, signature}: signature [%EllipticCurve.Signature.Data]: decoded signature, exposing r and s; Example: iex&gt; EllipticCurve.Ecdsa.fromBase64!(&quot;MEYCIQD861pJq/fZE7GnDBycwAbb3YglVoSCVub6TwMkgFS0NgIhAJCEZTh1Mlp1cWCgMXABqh9nOQznEXnhGoSYmZK6T99T&quot;) %EllipticCurve.Signature.Data{r: 114398670046563728651181765316495176217036114587592994448444521545026466264118, s: 65366972607021398158454632864220554542282541376523937745916477386966386597715}","ref":"EllipticCurve.Signature.html#fromBase64!/1","title":"EllipticCurve.Signature.fromBase64!/1","type":"function"},{"doc":"Converts a der signature (raw binary) into the decoded struct format Parameters: der [string]: signature in der format (raw binary) Returns {:ok, signature}: signature [%EllipticCurve.Signature.Data]: decoded signature, exposing r and s; Example: iex&gt; EllipticCurve.Ecdsa.fromDer(&lt;&lt;48, 69, 2, 33, 0, 211, 243, 12, 93, ...&gt;&gt;) {:ok, %EllipticCurve.Signature.Data{r: 95867440227398247533351136059968563162267771464707645727187625451839377520639, s: 35965164910442916948460815891253401171705649249124379540577916592403246631835}}","ref":"EllipticCurve.Signature.html#fromDer/1","title":"EllipticCurve.Signature.fromDer/1","type":"function"},{"doc":"Converts a der signature (raw binary) into the decoded struct format Parameters: der [string]: signature in der format (raw binary) Returns: signature [%EllipticCurve.Signature.Data]: decoded signature, exposing r and s; Example: iex&gt; EllipticCurve.Ecdsa.fromDer!(&lt;&lt;48, 69, 2, 33, 0, 211, 243, 12, 93, ...&gt;&gt;) %EllipticCurve.Signature.Data{r: 95867440227398247533351136059968563162267771464707645727187625451839377520639, s: 35965164910442916948460815891253401171705649249124379540577916592403246631835}","ref":"EllipticCurve.Signature.html#fromDer!/1","title":"EllipticCurve.Signature.fromDer!/1","type":"function"},{"doc":"Converts a signature in decoded struct format into a base 64 string Parameters: signature [%EllipticCurve.Signature.Data]: decoded signature struct; Returns: base64 [string]: signature in base 64 format Example: iex&gt; EllipticCurve.Ecdsa.toBase64(%EllipticCurve.Signature.Data{r: 123, s: 456}) &quot;YXNvZGlqYW9pZGphb2lkamFvaWRqc2Fpb3NkamE=&quot;","ref":"EllipticCurve.Signature.html#toBase64/1","title":"EllipticCurve.Signature.toBase64/1","type":"function"},{"doc":"Converts a signature in decoded struct format into der format (raw binary) Parameters: signature [%EllipticCurve.Signature.Data]: decoded signature struct; Returns: der [string]: signature in der format Example: iex&gt; EllipticCurve.Ecdsa.toDer(%EllipticCurve.Signature.Data{r: 95867440227398247533351136059968563162267771464707645727187625451839377520639, s: 35965164910442916948460815891253401171705649249124379540577916592403246631835}) &lt;&lt;48, 69, 2, 33, 0, 211, 243, 12, 93, 107, 214, 149, 243, ...&gt;&gt;","ref":"EllipticCurve.Signature.html#toDer/1","title":"EllipticCurve.Signature.toDer/1","type":"function"},{"doc":"","ref":"EllipticCurve.Signature.Data.html","title":"EllipticCurve.Signature.Data","type":"module"},{"doc":"Holds signature data. Is usually extracted from base64 strings. Parameters: r [integer]: first signature number; s [integer]: second signature number;","ref":"EllipticCurve.Signature.Data.html#__struct__/0","title":"EllipticCurve.Signature.Data.__struct__/0","type":"function"},{"doc":"","ref":"EllipticCurve.Utils.Point.html","title":"EllipticCurve.Utils.Point","type":"module"},{"doc":"Holds point data. Is usually handled internally by the library and serves only as detailed information to the end-user. Parameters: x [integer]: first point coordinate; y [integer]: first point coordinate; z [integer]: first point coordinate (used only in Jacobian coordinates);","ref":"EllipticCurve.Utils.Point.html#__struct__/0","title":"EllipticCurve.Utils.Point.__struct__/0","type":"function"}]